<?php
/**
 * PHP分页类
 * @data         查询条件
 * @page         页码
 * @gap          每页显示总数
 * @order        排序规则
 * @mobject      modle层对象
 * @Totol        记录总条数
 * @ResultSet    每一页的结果集
 * @PaginStyle   分页样式
 * @TotolPage    总页数
 */
 class Tool_Paging{
     
    
     private $Page;
     private $Gap;
     private $Totol;
     private $ResultSet;
     private $PaginStyle;
     private $TotolPage;
             
     function __construct($mobjet,$data=array('conditiondata'=>'','condition'=>''),$page=0,$gap=10,$order=' id desc ') {
              
         $this->page      = $page;
         $this->gap       = $gap;
         $this->Totol     = $this->GetTotol($mobjet,$data);
         $this->SetPage($mobjet,$data,$page,$gap,$order);
     }
     /**
      * 拦截器  
      * @param type $name
      * @return type
      */
     public function __get($name) {
         
         if(isset($this->$name)){
             return $this->$name;
         }
    }
     
     function SetPage($mobjet,$data,$page,$gap,$order){         
   
         //获取总条数
         $total_num = $this->Totol;
         
         //计算limit字串
         $total_page = $total_num%$gap == 0 ? $total_num/$gap : (int)($total_num/$gap)+1;
         if($page>$total_page) $page = $total_page;
         if($page<1) $page = 1;
         $downpage = $page-1;
         if($page==1) $downpage=1;
         if($page==$total_page) $downpage = $total_page-2;
         $k = ($page-1)*$gap;
         //计算limit字串
         if(empty($data['condition'])){
           $data['condition'] .= " 1=1 "; 
         }
         $data['condition'] .="order by  ".$order."  limit ".$k.','.$gap;
         //获取结果集         
         $Fatch   = $mobjet->GetAll($data);  
         $this->ResultSet   = $Fatch;
         $this->TotolPage   = $total_page;
         $this->PaginStyle  = $this->PateStyle($total_num,$total_page,$page,$gap,$downpage);
     }
     /**
      * 总记录数
      * @param type $data
      * @return int
      */
     function GetTotol($mobject,$data){
         if(empty($data['condition'])){
           $data['condition'] = ' 1=1 ';
         }
         $Totol = $mobject->GetTotol($data);              
         return $Totol;   
     }
     
     function PateStyle($total_num,$total_page,$page,$gap,$downpage){

            global $ControllorParms;
      $page0 = $page-1;                  
      $page1 = $page+1;
      $page2 = $page+2;
      $downpage1 = $downpage+1;
      $downpage2 = $downpage+2;
      $css = $page==$downpage?" over":"";
      $css1 = $page==$downpage1?" over":"";
      $css2 = $page==$downpage2?" over":"";               
      $url =  $_SERVER["QUERY_STRING"];
      $url =  '/'.str_replace('url=','',$url);                  
      $url = preg_replace('/\/page\/(\d)*(\/)*/i','',$url);    
      $re .= "<ul class='page clearfix'>";
      $re .="<li><span>每页显示：<input type='text' value=".$gap." class='emr'/> 条</span></li>";
      $re .="<li><span>共".$total_page."页/当前".$page."页</span></li>";
      $re .= "<li class='page_li'><a  href='".$url."/page/1'>首页</a></li>";
      $re .= "<li class='page_li'><a  href='".$url."/page/".$page0."'>上一页</a></li>";      
      if($total_page>3){
      $re .= "<li class='page_li".$css."'><a  href='".$url."/page/".$downpage."'>".$downpage."</a></li>";
      $re .= "<li class='page_li".$css1."'><a  href='".$url."/page/".$downpage1."'>".$downpage1."</a></li>";
      $re .="<li class='page_li".$css2."'><a   href='".$url."/page/".$downpage2."'>".$downpage2."</a></li>";
      }
      $re .= "<li class='page_li'><a title='下一页' href='".$url."/page/".$page1."'>下一页</a></li>";
      $re .= "<li class='page_li'><a title='尾页' href='".$url."/page/".$total_page."'>尾页</a></li>";      
      $re .="</ul>";
      return  $re;
     }
          
 }
?>